<?php

$lang_files = array(
	"include/language",
	"modules/Accounts/language",
	"modules/Activities/language",
	"modules/Administration/language",
	"modules/AgataReports/language",
	"modules/Calendar/language",
	"modules/Calls/language",
	"modules/Cases/language",
	"modules/Contacts/language",
	"modules/CustomView/language",
	"modules/Dashboard/language",
	"modules/Documents/language",
	"modules/Emails/language",
	"modules/Faq/language",
	"modules/Help/language",
	"modules/HelpDesk/language",
	"modules/Home/language",
	"modules/Import/language",
	"modules/Invoice/language",
	"modules/Leads/language",
	"modules/Meetings/language",
	"modules/MessageBoard/language",
	"modules/Migration/language",
	"modules/Notes/language",
	"modules/Orders/language",
	"modules/Potentials/language",
	"modules/PriceBooks/language",
	"modules/PurchaseOrder/language",
	"modules/Products/language",
	"modules/Quotes/language",
	"modules/Reports/language",
	"modules/Rss/language",
	"modules/SalesOrder/language",
	"modules/Settings/language",
	"modules/squirrelmail-1.4.4",
	"modules/squirrelmail-1.4.4/language",
	"modules/System/language",
	"modules/Tasks/language",
	"modules/uploads/language",
	"modules/Users/language",
	"modules/Vendors/language",
	"modules/Yahoo/language"
);


$unique = array(  );

$items = array();

foreach ( $lang_files as $dir )
{
	$file = "$dir/en_us.lang.php";
	if ( file_exists($file) )
	{
		$words = explode("/",$file);
		if ( $words[0] == "include" ) $words[1] = "Application";
		$unique[] = $current = $words[1];
		if ( !isset($items[$current]) )
			$items[$current] = array();		
		
		$dat = file_get_contents($file);
		$dat = preg_replace("#/\*.*\*/#imsU","",$dat);
		$dat = preg_replace("#//.*$#imsU","",$dat);
		include($file);
		preg_match_all("/[$]([A-Za-z0-9_]+) =/",$dat,$matches);
		foreach( $matches[1] as $string )
		{
			//if ( is_array($$string) ) var_dump($string,$$string); 
			$items[$current][$string] = $$string;
		}
		${$string} = null;
	}
}

@mkdir("locale");
$pot = fopen("locale/vtiger.php","w");
fwrite($pot,"<?php\n");

$sql = fopen("locale/lang_keys.sql","w");

fwrite($sql,"
DROP TABLE IF EXISTS `lang_keys`;
CREATE TABLE IF NOT EXISTS `lang_keys` (
  `kmodule` varchar(32) NOT NULL default '',
  `ktype` varchar(32) NOT NULL default '',
  `karray` varchar(32) NOT NULL default '',
  `kkey` varchar(80) NOT NULL default '',
  `default_value` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`kmodule`,`ktype`,`karray`,`kkey`),
  KEY `kkey` (`kkey`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;
");	

function pit($k1,$k2,$k3,$k4,$k5)
{
	global $pot,$sql;

	$k6 = str_replace('"',"'",$k5); 
	$key = "$k1_$k2_$k3_$k4";
	$key = str_replace(" ","_",$key);
	if ( $k3 == "" )
		$k3 = "*";
	fwrite($sql,"REPLACE INTO `lang_keys` VALUES (\"$k1\", \"$k2\", \"$k3\", \"$k4\", \"$k6\");
");
	if ( $key <> "" && $k5 <> "" )
	{
		$i = 1;
		$k5s = explode("\n",$k5);
		foreach ( $k5s as $k5 )
		{
			if ( $k5 <> "" )
				fwrite($pot,"\$$key$i=\"".trim($k5)."\";\n");
			$i++;
		}
	}
}

foreach ( $items as $key => $strings2 )
{
	foreach ( $strings2 as $key2 => $strings )
	{
		foreach ( $strings as $index => $value3 )
		{
			if ( is_array($value3) )
			{
				foreach ( $value3 as $key3 => $value )
				{
					pit($key,$key2,$index,$key3,$value);
				}
			}
			else
			{
				pit($key,$key2,"",$index,$value3);
			}
		}
	}
}	

fwrite($pot,"\n?>");
fclose($pot);
fclose($sql);
system("xgettext -a --no-location -o locale/vtiger.pot locale/vtiger.php");
?>
